'-------------------------------------------------------------------------------
'name                     : PXO_DivOpt_Test03.bas
'copyright                : (c) 2008, Dr. Chris Hirt, Austria
'purpose                  : Si570 New Frequency Calculation TEST
'micro                    : Atmel AT90S2313
'flash                    : 91% used (without print)
'compiler                 : MCS BASCOM 1.11.9.1 Demo
'build                    : 27032008 (27. Mar. 2008)
'status                   : testet (non-warranty!)
'-------------------------------------------------------------------------------

$regfile = "2313def.dat"                'AT90S2313
$crystal = 3686400                      'crystal frequency
$baud = 19200                           'baud rate
$hwstack = 40                           'hardware stack   32
$swstack = 30                           'SW stack         10
$framesize = 60                         'frame space      40

Const StartUpFreq = 56.32               'StartUpFrequency [MHz]
Const Fdco_max = 5670.0                 'FoscMAX [MHz]
Const Fdco_min = 4850.0                 'FoscMIN [MHz]

Dim InitHSDIV As Byte
Dim InitN1 As Byte
Dim HSDIV as Byte
Dim N1 as Byte
Dim InitRFREQ As Long
Dim FinalRFREQ as Long
Dim Testfreq as Single
Dim ratio as Single
Dim Validcombo as Byte
Dim Divider_max as Integer
Dim Curr_div as Integer
Dim d1 as Single , d2 as Single
Dim HSDIVA(6) as byte
Dim Curr_N1 as Single
Dim N1_tmp as Single
Dim nx as Byte
Dim ra as Single , rb as Single
Dim i As Byte
Dim sN1 As Single , sInitN1 As Single , sHSDIV As Single , sInitHSDIV As Single


'---- Main ---------------------------------------------------------------------

'###################### hard coded test data #############################

Testfreq = 100.0                        '[100 MHz]

InitHSDIV = 4
InitN1 = 22
InitRFREQ = &b1010_1101_0101_1101_1111_1100_0010_1100

HSDIVA(1) = 11
HSDIVA(2) = 9
HSDIVA(3) = 7
HSDIVA(4) = 6
HSDIVA(5) = 5
HSDIVA(6) = 4

'########################################################################

d1 = Fdco_max / Testfreq
d2 = Fdco_min / Testfreq
Divider_max = Fix(d1)                   'Floor()
Curr_div = Int(d2) + 1                  'Ceil()

Validcombo = 0
While Curr_div <= Divider_max
   For i = 1 To 6
      HSDIV = HSDIVA(i)                 '{11,9,7,6,5,4}
      Curr_N1 = Curr_div / HSDIV
      N1_tmp = Fix(Curr_N1)
      N1_tmp = Curr_N1 - N1_tmp

      'N1 = {1,2,4,6...128}
      'If N1 is an integer and an even number or 1 then N1 = valid

      If N1_tmp = 0.0 then              'then Curr_N1 is an integer
         N1 = Curr_N1
         nx = N1 AND 1
         If N1 = 1 then                 'then N1 = 1
            Validcombo = 1
         End If
         If nx = 0 then                 'or an even number
            Validcombo = 1
         End If
      End If
      If Validcombo = 1 then
          Goto breaklbl1
      End If
   Next i
   breaklbl1:
   If Validcombo = 1 then
      Goto breaklbl2
   End If
   Curr_div = Curr_div + 1
Wend
breaklbl2:

ratio = Testfreq / StartUpFreq
sN1 = N1 * 1.0
sInitN1 = InitN1 * 1.0
sHSDIV = HSDIV * 1.0
sInitHSDIV = InitHSDIV * 1.0
ra = sN1 / sInitN1
rb = sHSDIV / sInitHSDIV
ratio = ratio * ra
ratio = ratio * rb
FinalRFREQ = ratio * InitRFREQ          'Wow that's it

'Print FinalRFREQ                       'too big for memory

'##################################################################
' HSDIV = 5                               {4,5,6,7,9,11}
' N1 = 10                                 {1,2,4,6...128}
' RFREQ = &b1010_1100_1010_0010_1101_1111_0000_0000
'
' why lsb 0 ?
'##################################################################

End

'------------------------ End of PXO_DivOpt_Test03 -----------------------------