'-------------------------------------------------------------------------------
'name                     : Si570_I2C_Test_03
'copyright                : (c) 2008, Dipl.Ing. Dr. Christian Hirt, Austria
'purpose                  : Si570 I2C TEST
'micro                    : AT90S2313
'flash                    : 56% used
'build                    : 20032008 (20. Mar. 2008)
'status                   : tested (non-warranty!)
'-------------------------------------------------------------------------------

$regfile = "2313def.dat"                'AT90S2313
$crystal = 3686400                      'crystal frequency
$hwstack = 32                           'hardware stack
$swstack = 10                           'SW stack
$framesize = 40                         'frame space

Config SCL = Portb.0                    'I2C config
Config SDA = Portb.1

Const AddrSI570 = &H55                  'SI570 I2C slave base address
Const Si570WAdr = &HAA                  'I2C write byte
Const Si570RAdr = &HAB                  'I2C read  byte

' Config LCD
Config Lcdbus = 4
Config Lcd = 16 * 1a
Config Lcdmode = Port
Config Lcdpin = Pin , Rs = Portb.2 , E = Portb.3
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7

Declare Sub Write_Si570(Byval Addr As Byte , Byval Value As Byte)
Declare Function Read_Si570(Byval Addr As Byte) As Byte

Dim i As Byte
Dim a As Byte
Dim reg(6) As Byte

'---- Main ---------------------------------------------------------------------

Cursor Off
Cls
Lcd "Si570 - I2C Test"
Wait 2
Cls
Call Write_si570(135 , &B0000_0001)     'Recall the initial state in the NVM
For i = 1 To 6
   a = i + 6
   reg(i) = Read_Si570(a)               'Read registers 7 to 12 of Si570
   Lcd "REG" ; a ; ": " ; Bin(reg(i))   ' and write register to LCD
   Wait 5                               'wait 5 seconds
   Cls
Next i
Lcd "End of test"
End                                     'End of program

'--- I2C functions -------------------------------------------------------------

Sub Write_Si570(Byval Addr As Byte , Byval Value As Byte)       'write a byte
   I2cstart                             'start condition
   I2cwbyte Si570WAdr                   'write slave address from Si570
   I2cwbyte Addr                        'adress of Si570 register
   I2cwbyte Value                       'byte value to write
   I2cstop                              'stop condition
End Sub

Function Read_Si570(Byval Addr As Byte) As Byte       'read a byte from Si570
  Dim rdval As Byte
  rdval = 0
  I2cstart                              'start condition
  I2cwbyte Si570WAdr                    'write slave adress from Si570
  I2cwbyte Addr                         'address of Si570 register
  I2cstart                              'repeated start
  I2cwbyte Si570RAdr                    'slave address (read) from Si570
  I2crbyte rdval , Nack                 'read byte
  I2cstop                               'generate stop
  Read_Si570 = rdval
End Function

'------------------------ End of Si570_I2C_Test_03.bas--------------------------